class Permify::Authorization
  attr_reader :candidate
  def initialize(candidate)
    @candidate = candidate
  end

  def can?(action, resource)
    permission = find_permission(resource, action)
    permission.granted?(candidate, resource)
  end

  protected

  def find_permission(resource, action)
    candidate.permissions.find(resource, action)
  end
end
