# Clearance: Official authorization for something to proceed or take place
#
class Permify::Clearance
  def initialize(repo)
    @repo = repo
    @permissions = Permify::PermissionMap.new
  end

  def add(resource, action)
    permission = resolve_to_permission(resource, action)
    permissions.store(resource, action, permission)
  end

  def find(resource, action)
    if !repo.permission_combination?(resource, action)
      permissions.find(resource, action) || Permify::Permission::Null.new
    else
      combination = repo.find_permission_combination(resource, action)
      combination.resolve(self)
    end
  end

  private
  attr_reader :permissions, :repo

  def resolve_to_permission(resource, action_name)
    repo.find_permission(resource, action_name)
  end
end
