class Permify::Permission::CombinationMap
  def initialize(combinations)
    @combinations = combinations
  end

  def resolve(clearance)
    permissions = list_permissions(clearance)
    Permify::Permission::Combination::Any.new(permissions)
  end

  private
  attr_reader :combinations

  def list_permissions(clearance)
    permissions = []
    combinations.each do |resource, actions|
      [actions].flatten.each do |action|
        permissions << clearance.find(resource, action)
      end
    end
    permissions
  end
end
